program hadi;
{

HIPPO GAMES
(C) Pavel Krikava

Program a zdrojove texty tady okolo podlehaji pravidlum licence GPL
Viz. soubor COPYING

Autor nezodpovida za pripadnou ujmu na zdravi zpusobenou prectenim zdrojaku.

}
uses crt, graph, dos;
type buf1 = array[1..32767] of word;

type hrac=record
          x,y,z,v,vs,b,por: integer; {x,y:souradnice, z:0-zivy,1-mrtvy, v-pocitani vyher}
          zx,zy : integer; { zmena x, zmena y}
          end;  {vs: index, b:body, por: poradi hrace}

     polehracu = array [1..4] of hrac;

var
  gd, gm : integer; { grafika }
  pocet  : integer; { pocet hracu}
  start  : integer; { urcuje startovni x-ovou souradnici }
  pockat : integer; {delay v kazdem cyklu}
  level  : integer; {jakej je level}
  rychlost: integer; {rychlost hry}
  h, o, p, pom, pom2, rekord, pixelcolor: integer;
  cheat: boolean; {cheat mod}
  ch     : char;  { cteni znaku z klavesnice pri hre }
  zvuk   : char;  { urcuje, zda je zapnuty zvuk }
  t      : text;      {soubor s rekordem}
  ph     : polehracu; { hraci }
  BUF    : ^buf1;     {buffer}
  I,int,RES : word;
  int1   : pointer;   {stary casovac}
  f      : file;      {soubor se zmapou}
  ii     : integer;   {promena na cykly}

  label l; {na restart hry}


{--------------------- IntToStr--------------------------------}
{funkce prevadi integer na string}
function Inttostr (g:longint): string;
var s: string[11];
begin
Str (g,s);
inttostr:=s;
end;

{--------------------- INT_TIME---------------------------------}
{ obsluha interaptu }
procedure INT_TIME; interrupt;
begin
inc (int);
if int=res then int:=1;
if buf^[int] <> 0 then sound(buf^[int])
                   else nosound;
end;

{--------------------- NOVA HRA---------------------------------}
{ vypise Znovu? }
procedure nova_hra;
begin
  setcolor (15);
  SetTextStyle (Defaultfont, horizDir, 2);
  outtextXY (80,230,'Znovu:ENTER,SPACE  Konec:ESC');
  SetTextStyle (Defaultfont, horizDir, 1);
end;

{--------------------- VYHRY ---------------------------------}
{ pocita a zobrazuje vyhry }
procedure pocitani_a_zobrazovani_vyher;
begin
  if ((ph[1].z=1) and (ph[2].z=1) and (ph[3].z=1) and (ph[4].z=1)) then
  nova_hra
  else
  if ((ph[2].z=1) and (ph[3].z=1) and (ph[4].z=1)) then
  begin {vyhra 1. hrace}
     ph[1].x:=1; ph[1].y:=1;
     setcolor (0);
     outtextXY (175,5,inttostr (ph[1].v));
     ph[1].v:=ph[1].v+1;
     setcolor (10);
     outtextXY (175,5,inttostr (ph[1].v));
     nova_hra;
   end
   else
  if (((ph[1].x=1) or (ph[1].y=1)) and ((ph[3].x=1) or (ph[3].y=1)) and ((ph[4].x=1) or (ph[4].y=1))) then
   begin {vyhra 2. hrace}
     ph[2].x:=1; ph[2].y:=1;
     setcolor (0);
     outtextxy (205,5,inttostr (ph[2].v));
     ph[2].v:=ph[2].v+1;
     setcolor (13);
     outtextxy (205,5,inttostr (ph[2].v));
     nova_hra;
   end
   else
  if (((ph[1].x=1) or (ph[1].y=1)) and ((ph[2].x=1) or (ph[2].y=1)) and ((ph[4].x=1) or (ph[4].y=1))) then
   begin {vyhra 3. hrace}
     ph[3].x:=1; ph[3].y:=1;
     setcolor (0);
     outtextxy (235,5,inttostr (ph[3].v));
     ph[3].v:=ph[3].v+1;
     setcolor (6);
     outtextxy (235,5,inttostr (ph[3].v));
     nova_hra;
   end
   else
  if (((ph[1].x=1) or (ph[1].y=1)) and ((ph[2].x=1) or (ph[2].y=1)) and ((ph[3].x=1) or (ph[3].y=1))) then
   begin {vyhra 4. hrace}
     ph[4].x:=1; ph[4].y:=1;
     setcolor (0);
     outtextxy (265,5,inttostr (ph[4].v));
     ph[4].v:=ph[4].v+1;
     setcolor (3);
     outtextxy (265,5,inttostr (ph[4].v));
     nova_hra;
   end;
end;

{------------------------ DELAY ---------------------------------}
{meni delay podle poctu zijicich cervu}
procedure rychlost_23;
begin
if rychlost=1 then
  begin
  if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=1 then pockat:=8;{delay pri 3 hracich}
  if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=2 then pockat:=6;{delay pri 2 hracich}
  end;
  if rychlost=2 then
  begin
  if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=1 then pockat:=5;{delay pri 3 hracich}
  if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=2 then pockat:=3;{delay pri 2 hracich}
  end;
  if rychlost=3 then
  begin
  if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=1 then pockat:=2;{delay pri 3 hracich}
  if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=2 then pockat:=0;{delay pri 2 hracich}
  end;
end;

{-------------------------- VYSLEDKY ---------------------------------}
{Zobrazi zaverecnou tabulku}
procedure zobrazeni_vysledku;
begin
  for o:=1 to 4 do ph[o].vs:=o;
  for o:=1 to 3 do
  for p:=1 to 3 do
  if ph[p+1].v>ph[p].v then
  begin
  pom:=ph[p].v;
  pom2:=ph[p].vs;
  ph[p].v:=ph[p+1].v;
  ph[p].vs:=ph[p+1].vs;
  ph[p+1].v:=pom;
  ph[p+1].vs:=pom2;
  end;
  SetTextStyle (0, horizDir, 1);
  for p:=1 to 4 do ph[p].por:=p;
  if ph[1].v=ph[2].v then ph[2].por:=ph[1].por;{pri stejnem poctu bodu}
  if ph[2].v=ph[3].v then ph[3].por:=ph[2].por;{odladi poradi}
  if ph[3].v=ph[4].v then ph[4].por:=ph[3].por;
  cleardevice;               {vypis umisteni hracu a body}
  Setcolor (9);
  outtextXY (40,20,'Tabulka vytezu.');
  setcolor (15);
  outtextXY (40,460,'ZMACKNI: mezernik, ENTER, nebo ESC.');
  if ph[1].vs=1 then setcolor (10);
  if ph[1].vs=2 then setcolor (13);
  if ph[1].vs=3 then setcolor (6);
  if ph[1].vs=4 then setcolor (3);
  outtextXY (40,90,inttostr (ph[1].por));
  outtextXY (55,90,'. je hrac cislo');
  outtextXY (190,90,inttostr (ph[1].vs));
  outtextXY (220,90,'s');
  outtextXY (250,90,inttostr (ph[1].v));
  outtextXY (290,90,'vyhrami.');
  if ph[2].vs=1 then setcolor (10);
  if ph[2].vs=2 then setcolor (13);
  if ph[2].vs=3 then setcolor (6);
  if ph[2].vs=4 then setcolor (3);
  outtextXY (40,130,inttostr (ph[2].por));
  outtextXY (55,130,'. je hrac cislo ');
  outtextXY (190,130,inttostr (ph[2].vs));
  outtextXY (220,130,'s');
  outtextXY (250,130,inttostr (ph[2].v));
  outtextXY (290,130,'vyhrami.');
  if (pocet>2) then
  begin
  if ph[3].vs=1 then setcolor (10);
  if ph[3].vs=2 then setcolor (13);
  if ph[3].vs=3 then setcolor (6);
  if ph[3].vs=4 then setcolor (3);
  outtextXY (40,170,inttostr (ph[3].por));
  outtextXY (55,170,'. je hrac cislo');
  outtextXY (190,170,inttostr (ph[3].vs));
  outtextXY (220,170,'s');
  outtextXY (250,170,inttostr (ph[3].v));
  outtextXY (290,170,'vyhrami.');
  end;
  if (pocet>3) then
  begin
  if ph[4].vs=1 then setcolor (10);
  if ph[4].vs=2 then setcolor (13);
  if ph[4].vs=3 then setcolor (6);
  if ph[4].vs=4 then setcolor (3);
  outtextXY (40,210,inttostr (ph[4].por));
  outtextXY (55,210,'. je hrac cislo');
  outtextXY (190,210,inttostr (ph[4].vs));
  outtextXY (220,210,'s');
  outtextXY (250,210,inttostr (ph[4].v));
  outtextXY (290,210,'vyhrami.');
  end;
  ch:=#79;
  repeat
    ch:=readkey;
    if ch=#0 then ch:=readkey;
  until (ch=#32) or (ch=#27) or (ch=#13);
  SetTextStyle (Defaultfont, horizDir, 1);
  end;

{-------------------------- init -------------------------------}
{ inicializuje hru }
procedure init;
begin
cleardevice;
repeat
SetTextStyle (DefaultFont, HorizDir, 2); {uvodni obrazovka}
SetColor (13);
OutTextXY (230,10,'Hippo Games');
SetTextStyle (DefaultFont, HorizDir, 1);
setcolor (7);
OutTextXY (280,30,'uvadi hru');
SetTextStyle (DefaultFont, HorizDir, 2);
SetColor (12);
OutTextXY (265,50,'H A D I');
SetTextStyle (DefaultFont, HorizDir, 1);
setcolor (7);
OutTextXY (275,70,'ceska verze');
setcolor (10);
OutTextXY (287,100,'FREEWARE');
SetColor (15);
OutTextXY (197,130,'(C) Pavel "LinuX" Krikava 1999');
SetColor (12);
OutTextXY (145,160,'Pred spustenim si prectete soubor hadi.txt!');
SetColor (9);
OutTextXY (10,200,'OVLADANI');
SetColor (7);
OutTextXY (10,220,'Klavesy jsou uvedeny v poradi: nahoru, dolu, vlevo, vpravo.');
setcolor (10);
OutTextXY (10,230,'HRAC 1 - kurzorove klavesy.');
setcolor (13);
OutTextXY (10,240,'HRAC 2 - numericka klavesnice. (8546)');
setcolor (6);
OutTextXY (10,250,'HRAC 3 - keyboard leva cast. (dxzc)');
setcolor (3);
OutTextXY (10,260,'HRAC 4 - keyboard prava cast. (jnbm)');
setcolor (7);
OutTextXY (10,280,'ENTER, MEZERNIK - Dalsi kolo. ');
OutTextXY (10,290,'ESC, Ctrl+Break - Konec hry. ');
if keypressed then
begin
ch:=readkey;
  if ch=#0 then ch:=readkey;
  setcolor (0);
  SetTextStyle(4, 0, 1);
  case ch of
  #121: begin OutTextXY (60,350,(Zvuk)); if zvuk='A' then zvuk:='N' else zvuk:='A'; end;
  #122: begin OutTextXY (80,350,(Zvuk)); if zvuk='A' then zvuk:='N' else zvuk:='A'; end;
  #104: begin OutTextXY (160,360,inttostr (Pocet)); inc (pocet); if pocet=5 then pocet:=2; end;
  #118: begin OutTextXY (310,370,inttostr (h)); inc (h); if h=51 then h:=1; end;
  #108: begin OutTextXY (60,440,inttostr (level)); inc (level); if level=5 then level:=1; end;
  #114: begin OutTextXY (170,380,inttostr (rychlost)); inc (rychlost); if rychlost=4 then rychlost:=1; end;
  #59: if cheat=false then cheat:=true else cheat:=false;
  end;
  end;
  setcolor (9);
  OutTextXY (10,330,'NASTAVENI');
  SetColor (2);
  OutTextXY (10,350,'Z');
  OuttextXY (58,360,'h');
  OuttextXY (58,370,'v');
  OuttextXY (10,380,'R');
  OutTextXY (10,440,'L');
  SetColor (7);
  OutTextXY (20,350,'vuk: ');
  OutTextXY (60,350,(Zvuk));
  OuttextXY (10,360,'Pocet  racu (2-4):');
  OutTextXY (160,360,inttostr (Pocet));
  OuttextXY (10,370,'Pocet  yteztvi k ukonceni hry (1-50):');
  OutTextXY (310,370,inttostr (h));
  OuttextXY (10,380,' ychlost hry (1-3):');
  OutTextXY (170,380,inttostr (rychlost));
  OutTextXY (10,400,'Level 1 - Prazdna plocha.');
  OutTextXY (10,410,'Level 2 - Plocha rozdelena na 2 casti propojene uzkymi prulezy. ');
  OutTextXY (10,420,'Level 3 - Nahodne romisteny napis Linux.');
  OutTextXY (10,430,'Level 4 - Nahodne umistene tecky.');
  OutTextXY (10,440,' evel: ');
  OutTextXY (60,440,inttostr (level));
  SetTextStyle (DefaultFont, HorizDir, 2);
  SetColor (4);
  OutTextXY (10,460,'Start: ENTER, SPACE          Konec: ESC');
until (ch=#13) or (ch=#32) or (ch=#27);

if zvuk='A' then begin
   getintvec ($1c, int1);
   getmem(buf,sizeof(buf^));
   assign(f,'hadi.zsn');
   reset(f,1);
   blockread(f,RES,2);         {kolik polozek se bude cist ?}
   blockread(f,buf^,RES*2,I);  {nacteni bufferu buf, RES*2 - buffer je array of }
   close(f);                   {word, word= dva byte}
   setintvec ($1c, addr (int_time));
end;
assign (t,'hadi.qdx'); {nahraje rekord ze souboru}
reset (t);
read (t, rekord);
close (t);
rekord:=rekord+50000;
end;

{------------------------------ done ---------------------------}
procedure done;
begin
  assign (t,'hadi.qdx');      {zapise rekord do souboru}
  rewrite (t);
  writeln (t,rekord-50000);
  close (t);
  if zvuk='A' then begin
     setintvec ($1c, int1);
     nosound;
     freemem(buf,sizeof(buf^));
  end;
  closegraph;
  clrscr;
  writeln ('HADI (C) Pavel Krikava, Hippo games 1999.');
end;

{----------------------------- Zpracuj_znak ---------------------}
{ obsluhuje stisk klavesy pri hre }
function Zpracuj_znak : boolean;
begin
  ch:=readkey;
  if ch=#0 then ch:=readkey;
  zpracuj_znak := true;
  case ch of
    #32,#13 : zpracuj_znak := false;
       { 1. cerv : }
    #75 : begin
             if ph[1].zx <> 1 then ph[1].zx := -1;
             ph[1].zy := 0;
          end;
    #77 : begin
           if ph[1].zx <> -1 then ph[1].zx := 1;
           ph[1].zy := 0;
          end;
    #72 : begin
           ph[1].zx := 0;
           if ph[1].zy <> 1 then ph[1].zy := -1;
          end;
    #80 : begin
           ph[1].zx := 0;
           if ph[1].zy <> -1 then ph[1].zy := 1;
          end;
   { 2. cerv }
    #56 : begin
           ph[2].zx := 0;
           if ph[2].zy <> 1 then ph[2].zy := -1;
          end;
    #53 : begin
           ph[2].zx := 0;
           if ph[2].zy <> -1 then ph[2].zy := 1;
          end;
    #52 : begin
           if ph[2].zx <> 1 then ph[2].zx := -1;
           ph[2].zy := 0;
          end;
    #54 : begin
           if ph[2].zx <> -1 then ph[2].zx := 1;
           ph[2].zy := 0;
          end;
    { 3. cerv }
   #100 : begin
           ph[3].zx := 0;
           if ph[3].zy <> 1 then ph[3].zy := -1;
          end;
   #120 : begin
           ph[3].zx := 0;
           if ph[3].zy <> -1 then ph[3].zy := 1;
          end;
   #122 : begin
           if ph[3].zx <> 1 then ph[3].zx := -1;
           ph[3].zy := 0;
          end;
    #99 : begin
           if ph[3].zx <> -1 then ph[3].zx := 1;
           ph[3].zy := 0;
          end;
   { 4. cerv }
   #106 : begin
           ph[4].zx := 0;
           if ph[4].zy <> 1 then ph[4].zy := -1;
          end;
   #110 : begin
           ph[4].zx := 0;
           if ph[4].zy <> -1 then ph[4].zy := 1;
          end;
    #98 : begin
           if ph[4].zx <> 1 then ph[4].zx := -1;
           ph[4].zy := 0;
          end;
   #109 : begin
           if ph[4].zx <> -1 then ph[4].zx := 1;
           ph[4].zy := 0;
          end;
  end; { konec case }
end;


{---------------------------- begin -----------------------------}

begin
clrscr;
gd := detect;
initgraph(gd,gm,'');
if graphresult <> grok then begin
   writeln('Nepodarilo se zavest grafiku! Zkontrolujte, zda je u hry soubor EGAVGA.BGI.');
   halt(1);
end;
zvuk:='A'; pocet:=2; level:=1; h:=5; rychlost:=2;
repeat
  for ii:=1 to 4 do
  ph[ii].v:=0;
  ch:=#100;
  init;
  if ch=#27 then break;
  l:
  int:=0;
  ph[1].b:=0;{pri restartu hry nastavuje vsechny hodnoty na zakladni, krome rekordu}
  ph[2].b:=0;
  ph[3].b:=0;
  ph[4].b:=0;
  if rychlost=1 then pockat:=11; {zakladni delay pri vsech 4 hracich zivych}
  if rychlost=2 then pockat:=8;
  if rychlost=3 then pockat:=5;
  ch:=#55;
  start:=round (640/(pocet+1));
  for ii := 1 to 4 do begin
     ph[ii].zx:=0;
     ph[ii].zy:=-1;
     ph[ii].z:=0;
     ph[ii].x:=ii*start;
     ph[ii].y:=400;
  end;

  cleardevice;
  if level=2 then    {vykresluje plochu pro jednotlive levely}
  begin
   setcolor (4);
   line (1,200,200,200);
   line (220,200,420,200);
   line (440,200,639,200);
  end;
  if level=3 then
  begin
  randomize;
  setcolor (12);
  SetTextStyle (defaultfont, HorizDir, 2);
  for i:=1 to 6 do
  begin
  ii:=random (200);
  if ii<20 then ii:=20;
  outtextxy (random (550),ii,'Linux');
  end;
  end;
  if level=4 then
  begin
  for i:=1 to 60 do
  begin
  ii:=random (480);
  if ii<20 then ii:=20;
  putpixel (random (640),ii,15);
  end;
  end;
  SetLineStyle (SolidLn, 0, ThickWidth);
  SetColor (4);
   line (1,1,640,1);     {Vykresli na monitor zakladni plochu}
   line (1,1,1,480);
   line (638,478,638,1);
   line (638,478,1,478);  {az sem ohraniceni}
   line (120,1,120,15);
   line (1,15,639,15);
   line (530,1,530,15); {pred rekordem}
   SetTextStyle (DefaultFont, HorizDir, 1);
   setcolor (2);
   outtextxy (595,5,inttostr (rekord));
   setcolor (9);               {zobrazeni vyher a pixelu}
   outtextxy (125,5,'VYHRY');
   outtextxy (300,5,'PIXELY');
   setcolor (10);
   outtextXY (175,5,inttostr (ph[1].v));
   setcolor (13);
   outtextxy (205,5,inttostr (ph[2].v));
   setcolor (6);
   outtextxy (235,5,inttostr (ph[3].v));
   setcolor (3);
   outtextxy (265,5,inttostr (ph[4].v));
   setcolor (9);
   SetTextStyle (Defaultfont, horizDir, 1);
   OutTextXY (5,5,'HADI v1,00 (C)');

 repeat
  SetLineStyle (SolidLn, 0, NormWidth);
  SetColor (0);

  if keypressed then if Zpracuj_znak = false then goto l;

  if cheat=false then
  for ii:=1 to 4 do
  begin
  pixelcolor:= getpixel (ph[ii].x,ph[ii].y); {zjistuje barvu pixelu}
  if pixelcolor <> 0 then      {kdyz je jina, nez cerna, tak hodi cerva na}
  begin                        {1,1, kde taky neni cerna, tak se to furt}
  ph[ii].x:=1;                        {opakuje}
  ph[ii].y:=1;
  end;
  end
  else {cheat mod}
  for ii:=1 to 4 do
  begin
  pixelcolor:= getpixel (ph[ii].x,ph[ii].y);
  if (pixelcolor <> 0) and (pixelcolor <> 10) and (pixelcolor <> 13) and (pixelcolor <> 6) and (pixelcolor <> 3) then
  begin
  ph[ii].x:=1;
  ph[ii].y:=1;
  end;
  end;

  if pocet=2 then {nici prebytecne cervi}
  begin
  ph[3].x:=1; ph[3].y:=1;
  ph[4].x:=1; ph[4].y:=1;
  end;
  if pocet=3 then
  begin
  ph[4].x:=1; ph[4].y:=1;
  end;
  for ii:=1 to 4 do
  if (ph[ii].x=1) or (ph[ii].y=1) then ph[ii].z:=1;{prirazuje z jestli je mrtvej}
  putpixel (ph[1].x,ph[1].y,10); {vykresluje cervi}
  putpixel (ph[2].x,ph[2].y,13);
  putpixel (ph[3].x,ph[3].y,6);
  putpixel (ph[4].x,ph[4].y,3);

  for ii := 1 to 4 do begin {pohybuje cervi}
     ph[ii].x :=ph[ii].x+ph[ii].zx;
     ph[ii].y :=ph[ii].y+ph[ii].zy;
  end;

  rychlost_23; {prirazuje delay podle mrtvych cervu}

  pocitani_a_zobrazovani_vyher;

  if (ph[1].v=h) or (ph[2].v=h) or (ph[3].v=h) or (ph[4].v=h) then {prerusi hru pri urcitem poctu bodu}
  zobrazeni_vysledku;

  setcolor (0);
  outtextXY (360,5,inttostr (ph[1].b));        {smaze body}
  outtextxy (405,5,inttostr (ph[2].b));
  outtextxy (450,5,inttostr (ph[3].b));
  outtextxy (490,5,inttostr (ph[4].b));
  for ii:=1 to 4 do                            {pocita body}
  begin
  if ph[ii].z=0 then ph[ii].b:=ph[ii].b+1;
  if ph[ii].b>rekord then begin
  setcolor (0);
  outtextxy (595,5,inttostr (rekord));
  rekord:=ph[ii].b;
  setcolor (2);
  outtextxy (595,5,inttostr (rekord));
  end;
  end;

  setcolor (10);
  outtextXY (360,5,inttostr (ph[1].b));
  setcolor (13);
  outtextxy (405,5,inttostr (ph[2].b));
  setcolor (6);
  outtextxy (450,5,inttostr (ph[3].b));
  setcolor (3);
  outtextxy (490,5,inttostr (ph[4].b));
  setcolor (2);
  outtextxy(540,5,'REKORD');
  Delay (pockat);
until (ch=#32) or (ch=#27) or (ch=#13);
if ch=#27 then ch:=#32;
if zvuk='A' then begin
     setintvec ($1c, int1);
     nosound;
     freemem(buf,sizeof(buf^));
  end;
until ch=#27;
done;
end.
